class FullException extends Exception {
}

class EmptyException extends Exception {
}

class Stack {

	protected int[] store; // zum Speichern von Daten
	protected int current; // aktueller Index

	public Stack(int size) {
		this.store = new int[size];
		this.current = -1;
	}

	public boolean isFull() {
		return this.current == this.store.length - 1;
	}

	public boolean isEmpty() {
		return this.current == -1;
	}

	public void push(int value) throws FullException {
		if (!this.isFull()) {
			this.store[++this.current] = value;
		} else {
			throw new FullException();
		}
	}

	public int pop() throws EmptyException {
		if (!this.isEmpty()) {
			return this.store[this.current--];
		} else {
			throw new EmptyException();
		}
	}
}

class NoPopException extends Exception {	
}

class UndoPopStack extends Stack {
	
	int lastValue;
	boolean popExists;
	
	public UndoPopStack(int size) {
		super(size);
		this.popExists = false;
	}
	
	public int pop() throws EmptyException {
		this.popExists = false;
		this.lastValue = super.pop();
		this.popExists = true;
		return this.lastValue;
	}
	
	public void undoPop() throws NoPopException, FullException {
		if (!popExists) {
			throw new NoPopException();
		}
		super.push(this.lastValue);
	}
}

public class UE21Aufgabe19 {

	// Testprogramm
	public static void main(String[] args) throws Exception {
		UndoPopStack stack = new UndoPopStack(10);
		stack.push(8);
		stack.pop();
		stack.push(4);
		stack.push(7);
		stack.pop();
		stack.push(1);
		stack.undoPop();
		stack.push(2);
		stack.undoPop();
		while (!stack.isEmpty()) {
			System.out.println(stack.pop());
		}
	}

}
