import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class UE21Aufgabe28 {

	public static void main(String[] args) throws Exception {

	}

	static void ohneExceptions(String vonDateiName, String summeDateiName)
			throws Exception {
		// Datei oeffnen
		BufferedReader quelle = new BufferedReader(new FileReader(vonDateiName));
		
		// Zahlen auslesen und Summe berechnen
		int summe = 0;
		String zeile = quelle.readLine();
		while (zeile != null) {
			summe += new Integer(zeile);
			zeile = quelle.readLine();
		}
		
		// Datei schliessen
		quelle.close();

		// Datei oeffnen
		PrintWriter senke = new PrintWriter(new FileWriter(summeDateiName));
		
		// Summe in Datei schreiben
		senke.println(summe);
		senke.flush();
		
		// Datei schliessen
		senke.close();
		
		// Ausgabe
		System.out
				.println("Datei wurde erzeugt und speichert Summe = " + summe);
	}

	static void mitExceptions(String vonDateiName, String summeDateiName) {
		int summe = 0;

		BufferedReader quelle = null;
		try {
			quelle = new BufferedReader(new FileReader(vonDateiName));
			String zeile = quelle.readLine();
			while (zeile != null) {
				try {
					summe += new Integer(zeile);
				} catch (NumberFormatException exc) {
					// Zeile wird ignoriert
				}
				zeile = quelle.readLine();
			}
		} catch (IOException e) {
			// Lesen wird abgebrochen
		} finally {
			// Reader muss auf jeden Fall geschlossen werden
			if (quelle != null) {
				try {
					quelle.close();
				} catch (IOException e) {
					// diese Exception wurde in der Aufgabenstellung ignoriert
					// und ist nicht notwendig zu behandeln
				}
			}
		}

		PrintWriter senke = null;
		try {
			senke = new PrintWriter(new FileWriter(summeDateiName));
			senke.println(summe);
			senke.flush();
			System.out.println("Datei wurde erzeugt und speichert Summe = "
					+ summe);
		} catch (IOException e) {
		} finally {
			// Writer muss auf jeden Fall geschlossen werden
			if (senke != null) {
				senke.close();
			}
		}
	}
}

