
class NichtGenugGuthabenException extends Exception {
}

class UngueltigerWertException extends Exception {
}

class KeinEinsatzException extends Exception {
}

class GeldspielAutomat {

	int guthaben;
	int einsatz;

	GeldspielAutomat() {
		guthaben = 0;
		einsatz = 0;
	}

	void geldEinwerfen(int geld) throws UngueltigerWertException {
		if (geld <= 0) {
			throw new UngueltigerWertException();
		}
		guthaben += geld;
	}

	void einsatzFestlegen(int einsatz) throws UngueltigerWertException, NichtGenugGuthabenException {
		if (einsatz <= 0) {
			throw new UngueltigerWertException();
		}
		if (einsatz > guthaben) {
			throw new NichtGenugGuthabenException();
		}
		this.einsatz = einsatz;
	}

	int getGuthaben() {
		return this.guthaben;
	}

	int auszahlen() {
		int speicher = guthaben;
		guthaben = 0;
		return speicher;
	}

	boolean spielen() throws KeinEinsatzException {
		if (einsatz <= 0) {
			throw new KeinEinsatzException();
		}
		int zahl1 = (int) (Math.random() * 6);
		int zahl2 = (int) (Math.random() * 6);
		if (zahl1 == zahl2) {
			guthaben += einsatz * 3;
			einsatz = 0;
			return true;
		} else {
			guthaben -= einsatz;
			einsatz = 0;
			return false;
		}
	}
}

public class UE21Aufgabe29 {

	public static void main(String[] args) throws Exception {
		GeldspielAutomat automat = new GeldspielAutomat();
		// ...
		automat.geldEinwerfen(IO.readInt("Einwerfen: "));
		// ...
		automat.einsatzFestlegen(IO.readInt("Einsatz: "));
		if (automat.spielen()) {
			System.out.println("gewonnen");
		} else {
			System.out.println("verloren");
		}
		System.out.println("Guthaben = " + automat.getGuthaben());
		// ...
		int geld = automat.auszahlen();
		// ...
	}
}
