


class ExtStack extends Stack {
	ExtStack(int size) {
		super(size);
	}

	boolean isFull() {
		try {
			push(0);
			pop();
			return false;
		} catch (FullException exc) {
			return true;
		} catch (EmptyException exc) {
			// nicht moeglich
			return false;
		}
	}

	boolean isEmpty() {
		try {
			int value = pop();
			push(value);
			return false;
		} catch (EmptyException exc) {
			return true;
		} catch (FullException exc) {
			// nicht moeglich
			return false;
		}
	}
}

final class FullException extends Exception {
}

final class EmptyException extends Exception {
}

class Stack {

	private int[] store; // zum Speichern von Daten
	private int current; // aktueller Index

	Stack(int size) {
		this.store = new int[size];
		this.current = -1;
	}

	final void push(int value) throws FullException {
		if (this.current == this.store.length - 1)
			throw new FullException();
		this.store[++this.current] = value;
	}

	final int pop() throws EmptyException {
		if (this.current == -1)
			throw new EmptyException();
		return this.store[this.current--];
	}
}


public class UE21Aufgabe34 {

	public static void main(String[] args) throws FullException, EmptyException {
		ExtStack stack = new ExtStack(5);
		while (!stack.isFull()) {
			stack.push(IO.readInt());
		}
		while (!stack.isEmpty()) {
			IO.println(stack.pop());
		}

	}

}
